# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from increase import Increase, AsyncIncrease
from tests.utils import assert_matches_type
from increase.types import Group

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestGroups:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_retrieve_details(self, client: Increase) -> None:
        group = client.groups.retrieve_details()
        assert_matches_type(Group, group, path=["response"])

    @parametrize
    def test_raw_response_retrieve_details(self, client: Increase) -> None:
        response = client.groups.with_raw_response.retrieve_details()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        group = response.parse()
        assert_matches_type(Group, group, path=["response"])

    @parametrize
    def test_streaming_response_retrieve_details(self, client: Increase) -> None:
        with client.groups.with_streaming_response.retrieve_details() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            group = response.parse()
            assert_matches_type(Group, group, path=["response"])

        assert cast(Any, response.is_closed) is True


class TestAsyncGroups:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    async def test_method_retrieve_details(self, async_client: AsyncIncrease) -> None:
        group = await async_client.groups.retrieve_details()
        assert_matches_type(Group, group, path=["response"])

    @parametrize
    async def test_raw_response_retrieve_details(self, async_client: AsyncIncrease) -> None:
        response = await async_client.groups.with_raw_response.retrieve_details()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        group = response.parse()
        assert_matches_type(Group, group, path=["response"])

    @parametrize
    async def test_streaming_response_retrieve_details(self, async_client: AsyncIncrease) -> None:
        async with async_client.groups.with_streaming_response.retrieve_details() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            group = await response.parse()
            assert_matches_type(Group, group, path=["response"])

        assert cast(Any, response.is_closed) is True
